=== debian/changelog ===
libtcod (1.18.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update Vcs-* and Files-Excluded fields.
  * Upgrade to Standards-Version 4.6.0 and debhelper compat level 13.
  * Update debian/rules.
  * Update 00-fix-makefile.patch.
  * Update years in debian/copyright.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sat, 11 Sep 2021 18:03:34 +0200
