=== debian/control ===
Source: libtcod
Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               libsdl2-dev,
               zlib1g-dev,
               python3
Standards-Version: 4.6.0
Homepage: https://github.com/libtcod/libtcod
Vcs-Git: https://salsa.debian.org/wolff/libtcod.git
Vcs-Browser: https://salsa.debian.org/wolff/libtcod

Package: libtcod1
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: graphics and utility library for roguelike developers
 Libtcod offers a free, fast, portable and uncomplicated API for
 roguelike developers providing an advanced true color console, input
 and lots of other utilities frequently used in roguelikes.
 .
 This package contains the runtime libraries. You shouldn't have to
 install it manually.

Package: libtcod-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: libtcod1 (= ${binary:Version}),
         libsdl2-dev,
         ${misc:Depends}
Description: development files for the libtcod roguelike library
 Libtcod offers a free, fast, portable and uncomplicated API for
 roguelike developers providing an advanced true color console, input
 and lots of other utilities frequently used in roguelikes.
 .
 This package contains the development files.
