## libtcod 1.24.0%2Bdfsg

=== buildsys/scons/SConstruct ===
--- 
+++ 
@@ -1,11 +1,10 @@
+import multiprocessing
 import os
-import sys
-
-import multiprocessing
 import platform
 import re
 import shutil
 import subprocess
+import sys
 import tarfile
 import time
 import zipfile
@@ -327,7 +326,7 @@
 if using_msvc:
     env.Prepend(CXXFLAGS=["-EHsc"])
 if not using_msvc:
-    env.Prepend(CFLAGS=["-std=c99"], CXXFLAGS=["-std=c++14"])
+    env.Prepend(CFLAGS=["-std=c99"], CXXFLAGS=["-std=c++17"])
 
 
 if using_msvc:
