=== samples/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.9)
+cmake_minimum_required (VERSION 3.13...3.21)
 
 project (libtcod_samples C CXX)
 
@@ -38,11 +38,20 @@
 add_compile_options("$<$<C_COMPILER_ID:MSVC>:/utf-8>")
 add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")
 
+# Enable extra warnings for all samples.
+if(MSVC)
+    add_compile_options("/W4")
+else()
+    add_compile_options("-Wall" "-Wextra")
+endif()
+
 add_executable(samples_c samples_c.c)
 target_link_libraries(samples_c ${LINK_TCOD} ${SDL2MAIN})
 if (CONAN_FILE)
     add_dependencies(samples_c copy_data_dir)
 endif()
+# Suppress MSVC warnings for POSIX C functions such as strdup.  This is only for the C samples.
+target_compile_definitions(samples_c PRIVATE "$<$<C_COMPILER_ID:MSVC>:_CRT_NONSTDC_NO_DEPRECATE>")
 
 add_executable(samples_cpp samples_cpp.cpp)
 target_link_libraries(samples_cpp ${LINK_TCOD} ${SDL2MAIN})
@@ -51,7 +60,7 @@
 endif()
 
 add_executable(frost frost/frost.cpp)
-target_link_libraries(frost ${LINK_TCOD} SDL2::SDL2main SDL2::SDL2)
+target_link_libraries(frost ${LINK_TCOD} ${SDL2MAIN})
 if (CONAN_FILE)
     add_dependencies(frost copy_font)
 endif()
@@ -59,13 +68,13 @@
 add_executable(hmtool
     hmtool/hmtool.cpp hmtool/operation.cpp hmtool/operation.hpp
 )
-target_link_libraries(hmtool ${LINK_TCOD})
+target_link_libraries(hmtool ${LINK_TCOD} ${SDL2MAIN})
 if (CONAN_FILE)
     add_dependencies(hmtool copy_font)
 endif()
 
-add_executable(navier navier/main.cpp navier/main.hpp)
-target_link_libraries(navier ${LINK_TCOD})
+add_executable(navier navier/main.cpp)
+target_link_libraries(navier ${LINK_TCOD} ${SDL2MAIN})
 if (CONAN_FILE)
     add_dependencies(navier copy_font)
 endif()
@@ -79,7 +88,7 @@
     rad/rad_shader_photon.cpp
     rad/rad_shader_standard.cpp
 )
-target_link_libraries(rad ${LINK_TCOD})
+target_link_libraries(rad ${LINK_TCOD} ${SDL2MAIN})
 if (CONAN_FILE)
     add_dependencies(rad copy_font)
 endif()
@@ -90,7 +99,7 @@
     ripples/util_ripples.cpp
     ripples/util_ripples.hpp
 )
-target_link_libraries(ripples ${LINK_TCOD})
+target_link_libraries(ripples ${LINK_TCOD} ${SDL2MAIN})
 if (CONAN_FILE)
     add_dependencies(ripples copy_font)
 endif()
@@ -101,7 +110,7 @@
     weather/util_weather.cpp
     weather/util_weather.hpp
 )
-target_link_libraries(weather ${LINK_TCOD})
+target_link_libraries(weather ${LINK_TCOD} ${SDL2MAIN})
 if (CONAN_FILE)
     add_dependencies(weather copy_font)
 endif()
@@ -112,7 +121,36 @@
     worldgen/util_worldgen.cpp
     worldgen/util_worldgen.hpp
 )
-target_link_libraries(worldgen ${LINK_TCOD})
+target_link_libraries(worldgen ${LINK_TCOD} ${SDL2MAIN})
 if (CONAN_FILE)
     add_dependencies(worldgen copy_font)
 endif()
+
+if (EMSCRIPTEN)
+    # Attach data to Emscripten builds.
+    foreach(project_it samples_c samples_cpp)
+        target_link_options(
+            ${project_it} PRIVATE
+            "SHELL:--preload-file ${CMAKE_CURRENT_SOURCE_DIR}/../data/fonts/dejavu10x10_gs_tc.png@/data/fonts/"
+            "SHELL:--preload-file ${CMAKE_CURRENT_SOURCE_DIR}/../data/img@/data/img/"
+            "SHELL:--preload-file ${CMAKE_CURRENT_SOURCE_DIR}/../data/namegen@/data/namegen/"
+        )
+    endforeach()
+    target_link_options(
+        frost PRIVATE
+        "SHELL:--preload-file ${CMAKE_CURRENT_SOURCE_DIR}/../data/fonts/terminal8x8_gs_tc.png@/data/fonts/"
+    )
+    foreach(project_it hmtool navier rad weather worldgen)
+        target_link_options(
+            ${project_it} PRIVATE
+            "SHELL:--preload-file ${CMAKE_CURRENT_SOURCE_DIR}/../data@/data/"
+        )
+    endforeach()
+
+    # Set output to html to generate preview pages, otherwise you'll have to make your own html.
+    set_target_properties(
+        samples_c samples_cpp frost hmtool navier rad weather worldgen
+        PROPERTIES
+            SUFFIX ".html"
+    )
+endif()
