=== debian/changelog ===
libtcod (1.24.0+dfsg-1) unstable; urgency=medium

  * New upstream release;
  * New maintainer (Closes: #1094602).

 -- Nikolay Shaplov <dhyan@nataraj.su>  Sat, 22 Feb 2025 21:05:32 +0300

libtcod (1.18.1+dfsg-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix incompatible pointer type build error. (Closes: #1075212)
  * Fix debian/watch to find new versions on GitHub.

 -- Nikolay Shaplov <dhyan@nataraj.su>  Sun, 26 Jan 2025 22:22:22 +0300

libtcod (1.18.1+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062648

 -- Graham Inggs <ginggs@debian.org>  Wed, 28 Feb 2024 19:17:26 +0000
