=== debian/control ===
--- 
+++ 
@@ -1,18 +1,21 @@
 Source: libtcod
-Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
+Maintainer: Nikolay Shaplov <dhyan@nataraj.su>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                pkg-config,
                libsdl2-dev,
                zlib1g-dev,
                python3
 Standards-Version: 4.6.0
 Homepage: https://github.com/libtcod/libtcod
-Vcs-Git: https://salsa.debian.org/wolff/libtcod.git
-Vcs-Browser: https://salsa.debian.org/wolff/libtcod
+Vcs-Git: https://salsa.debian.org/debian/libtcod.git
+Vcs-Browser: https://salsa.debian.org/debian/libtcod
 
-Package: libtcod1
+Package: libtcod1t64
+Provides: ${t64:Provides}
+Replaces: libtcod1
+Breaks: libtcod1 (<< ${source:Version})
 Architecture: linux-any
 Multi-Arch: same
 Depends: ${misc:Depends},
@@ -30,7 +33,7 @@
 Architecture: linux-any
 Multi-Arch: same
 Section: libdevel
-Depends: libtcod1 (= ${binary:Version}),
+Depends: libtcod1t64 (= ${binary:Version}),
          libsdl2-dev,
          ${misc:Depends}
 Description: development files for the libtcod roguelike library
