=== debian/watch ===
version=4
https://github.com/libtcod/libtcod/tags .*/v?(\d.*)@ARCHIVE_EXT@
